C----------------------------------------------------------------------C
      SUBROUTINE SetLC(lc1,lc2,lc3)
      
      REAL(8) lc1(27),lc2(27),lc3(27)
      INTEGER i


      lc1(1)=0.0D+0
      lc1(2)=0.0D+0
      lc1(3)=1.0D+0
      lc1(4)=1.0D+0
      lc1(5)=0.0D+0
      lc1(6)=0.0D+0
      lc1(7)=1.0D+0
      lc1(8)=1.0D+0
      lc1(9)=0.0D+0
      lc1(10)=5.0D-1
      lc1(11)=1.0D+0
      lc1(12)=5.0D-1
      lc1(13)=0.0D+0
      lc1(14)=0.0D+0
      lc1(15)=1.0D+0
      lc1(16)=1.0D+0
      lc1(17)=0.0D+0
      lc1(18)=5.0D-1
      lc1(19)=1.0D+0
      lc1(20)=5.0D-1
      lc1(21)=5.0D-1
      lc1(22)=0.0D+0
      lc1(23)=5.0D-1
      lc1(24)=1.0D+0
      lc1(25)=5.0D-1
      lc1(26)=5.0D-1
      lc1(27)=5.0D-1
     
      lc2(1)=1.0D+0
      lc2(2)=1.0D+0
      lc2(3)=1.0D+0
      lc2(4)=1.0D+0
      lc2(5)=0.0D+0
      lc2(6)=0.0D+0
      lc2(7)=0.0D+0
      lc2(8)=0.0D+0
      lc2(9)=1.0D+0
      lc2(10)=1.0D+0
      lc2(11)=1.0D+0
      lc2(12)=1.0D+0
      lc2(13)=5.0D-1
      lc2(14)=5.0D-1
      lc2(15)=5.0D-1
      lc2(16)=5.0D-1
      lc2(17)=0.0D+0
      lc2(18)=0.0D+0
      lc2(19)=0.0D+0
      lc2(20)=0.0D+0
      lc2(21)=1.0D+0
      lc2(22)=5.0D-1
      lc2(23)=5.0D-1
      lc2(24)=5.0D-1
      lc2(25)=5.0D-1
      lc2(26)=0.0D+0
      lc2(27)=5.0D-1
     
      lc3(1)=1.0D+0
      lc3(2)=0.0D+0
      lc3(3)=0.0D+0
      lc3(4)=1.0D+0
      lc3(5)=1.0D+0
      lc3(6)=0.0D+0
      lc3(7)=0.0D+0
      lc3(8)=1.0D+0
      lc3(9)=5.0D-1
      lc3(10)=0.0D+0
      lc3(11)=5.0D-1
      lc3(12)=1.0D+0
      lc3(13)=1.0D+0
      lc3(14)=0.0D+0
      lc3(15)=0.0D+0
      lc3(16)=1.0D+0
      lc3(17)=5.0D-1
      lc3(18)=0.0D+0
      lc3(19)=5.0D-1
      lc3(20)=1.0D+0
      lc3(21)=5.0D-1
      lc3(22)=5.0D-1
      lc3(23)=0.0D+0
      lc3(24)=5.0D-1
      lc3(25)=1.0D+0
      lc3(26)=5.0D-1
      lc3(27)=5.0D-1  


c     ker se mi ni dalo na novo natipkat     
      DO i=1,27
        lc1(i)=lc1(i)*2.0D0-1.0D0            
        lc2(i)=lc2(i)*2.0D0-1.0D0      
        lc3(i)=lc3(i)*2.0D0-1.0D0              
      END DO
 
      END


C----------------------------------------------------------------------C

      SUBROUTINE setGRAD(mesh,u,gradu)
C
C     Calculate field function derivaties, weighted average using cell volume
C      
      INCLUDE 'inc_types.f'   

      TYPE(meshType) :: mesh
      INTEGER l,ic,it,dn

      REAL(8) dfidxi(mesh%npoc),dfideta(mesh%npoc),dfidzeta(mesh%npoc)
      REAL(8) x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,
     &        x5,y5,z5,x6,y6,z6,x7,y7,z7,x8,y8,z8,
     &        dxidx,detadx,dzetadx,
     &        dxidy,detady,dzetady,
     &        dxidz,detadz,dzetadz,ajac,
     &        dfildx,dfildy,dfildz    
     
      REAL(8) lc1(27),lc2(27),lc3(27)
      REAL(8) u(mesh%nnodes),gradu(mesh%nnodes,3)
      REAL(8) utez,tmpgradu(3),vsotautezi(mesh%nnodes)

      REAL(8), ALLOCATABLE :: NodeVol(:) ! sum of all weights per node
      
      ALLOCATE (NodeVol(mesh%nicell))
      NodeVol=0.0D0
      CALL SetLC(lc1,lc2,lc3)

c     init
      gradu=0.0D0
      vsotautezi=0.0D0
            
      DO ic=1,mesh%nicell  ! po vseh celicah v mrezi
          utez=1.0D0/mesh%vol(ic)
          x1=mesh%x(mesh%idc(ic,6),1)
          y1=mesh%x(mesh%idc(ic,6),2)
          z1=mesh%x(mesh%idc(ic,6),3)          
          x2=mesh%x(mesh%idc(ic,7),1)
          y2=mesh%x(mesh%idc(ic,7),2)
          z2=mesh%x(mesh%idc(ic,7),3)          
          x3=mesh%x(mesh%idc(ic,2),1)
          y3=mesh%x(mesh%idc(ic,2),2)
          z3=mesh%x(mesh%idc(ic,2),3)          
          x4=mesh%x(mesh%idc(ic,3),1)
          y4=mesh%x(mesh%idc(ic,3),2)
          z4=mesh%x(mesh%idc(ic,3),3)          
          x5=mesh%x(mesh%idc(ic,5),1)
          y5=mesh%x(mesh%idc(ic,5),2)
          z5=mesh%x(mesh%idc(ic,5),3)          
          x6=mesh%x(mesh%idc(ic,8),1)
          y6=mesh%x(mesh%idc(ic,8),2)
          z6=mesh%x(mesh%idc(ic,8),3)          
          x7=mesh%x(mesh%idc(ic,1),1)
          y7=mesh%x(mesh%idc(ic,1),2)
          z7=mesh%x(mesh%idc(ic,1),3)          
          x8=mesh%x(mesh%idc(ic,4),1)
          y8=mesh%x(mesh%idc(ic,4),2)
          z8=mesh%x(mesh%idc(ic,4),3)           
        DO it=1,mesh%npoc ! po vseh vozliscih znotraj ene celice
          dn=mesh%idc(ic,it)
c         lokalne koordinate it-tega vozlica so v lc1,lc2,lc3
c          print *,lc1(it),lc2(it),lc3(it)
c         rabim odvode vseh interpolacijskih funkcij v tej tocki
          CALL cshaped27(lc1(it),lc2(it),lc3(it),dfidxi,dfideta,dfidzeta,mesh%npoc)
c         rabim d(xi)/dx, itd
          CALL detJac3Dlcd(lc1(it),lc2(it),lc3(it),
     &        x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,
     &        x5,y5,z5,x6,y6,z6,x7,y7,z7,x8,y8,z8,
     &        dxidx,detadx,dzetadx,
     &        dxidy,detady,dzetady,
     &        dxidz,detadz,dzetadz,ajac)


          tmpgradu(1)=0.0D0 
          tmpgradu(2)=0.0D0
          tmpgradu(3)=0.0D0                    
          DO l=1,mesh%npoc ! vsota za izracun odvoda v dn-tem vozliscu

            dfildx=dfidxi(l)*dxidx+dfideta(l)*detadx+dfidzeta(l)*dzetadx
            dfildy=dfidxi(l)*dxidy+dfideta(l)*detady+dfidzeta(l)*dzetady
            dfildz=dfidxi(l)*dxidz+dfideta(l)*detadz+dfidzeta(l)*dzetadz

            tmpgradu(1)=tmpgradu(1)+u(mesh%idc(ic,l))*dfildx
            tmpgradu(2)=tmpgradu(2)+u(mesh%idc(ic,l))*dfildy
            tmpgradu(3)=tmpgradu(3)+u(mesh%idc(ic,l))*dfildz                        
          END DO  
        gradu(dn,1)=gradu(dn,1)+tmpgradu(1)*utez
        gradu(dn,2)=gradu(dn,2)+tmpgradu(2)*utez
        gradu(dn,3)=gradu(dn,3)+tmpgradu(3)*utez
        vsotautezi(dn)=vsotautezi(dn)+utez     
        END DO         
      END DO      
      
      DO dn=1,mesh%nnodes
        gradu(dn,1)=gradu(dn,1)/vsotautezi(dn)
        gradu(dn,2)=gradu(dn,2)/vsotautezi(dn)
        gradu(dn,3)=gradu(dn,3)/vsotautezi(dn)
      END DO

      DEALLOCATE (NodeVol)
            
      END   

C----------------------------------------------------------------------C

      SUBROUTINE setGRADslab(mesh,u,gradu)
C
C     Calculate field function derivaties
C      
      INCLUDE 'inc_types.f'   

      TYPE(meshType) :: mesh
      INTEGER l,ic,it,dn

      REAL(8) dfidxi(mesh%npoc),dfideta(mesh%npoc),dfidzeta(mesh%npoc)
      REAL(8) x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,
     &        x5,y5,z5,x6,y6,z6,x7,y7,z7,x8,y8,z8,
     &        dxidx,detadx,dzetadx,
     &        dxidy,detady,dzetady,
     &        dxidz,detadz,dzetadz,ajac,
     &        dfildx,dfildy,dfildz    
     
      REAL(8) lc1(27),lc2(27),lc3(27)
      REAL(8) u(mesh%nnodes),gradu(mesh%nnodes,3)

      
      CALL SetLC(lc1,lc2,lc3)

c     init
      gradu=0.0D0
            
      DO ic=1,mesh%nicell  ! po vseh celicah v mrezi
          x1=mesh%x(mesh%idc(ic,6),1)
          y1=mesh%x(mesh%idc(ic,6),2)
          z1=mesh%x(mesh%idc(ic,6),3)          
          x2=mesh%x(mesh%idc(ic,7),1)
          y2=mesh%x(mesh%idc(ic,7),2)
          z2=mesh%x(mesh%idc(ic,7),3)          
          x3=mesh%x(mesh%idc(ic,2),1)
          y3=mesh%x(mesh%idc(ic,2),2)
          z3=mesh%x(mesh%idc(ic,2),3)          
          x4=mesh%x(mesh%idc(ic,3),1)
          y4=mesh%x(mesh%idc(ic,3),2)
          z4=mesh%x(mesh%idc(ic,3),3)          
          x5=mesh%x(mesh%idc(ic,5),1)
          y5=mesh%x(mesh%idc(ic,5),2)
          z5=mesh%x(mesh%idc(ic,5),3)          
          x6=mesh%x(mesh%idc(ic,8),1)
          y6=mesh%x(mesh%idc(ic,8),2)
          z6=mesh%x(mesh%idc(ic,8),3)          
          x7=mesh%x(mesh%idc(ic,1),1)
          y7=mesh%x(mesh%idc(ic,1),2)
          z7=mesh%x(mesh%idc(ic,1),3)          
          x8=mesh%x(mesh%idc(ic,4),1)
          y8=mesh%x(mesh%idc(ic,4),2)
          z8=mesh%x(mesh%idc(ic,4),3)           
        DO it=1,mesh%npoc ! po vseh vozliscih znotraj ene celice
          dn=mesh%idc(ic,it)
c         lokalne koordinate it-tega vozlica so v lc1,lc2,lc3
c          print *,lc1(it),lc2(it),lc3(it)
c         rabim odvode vseh interpolacijskih funkcij v tej tocki
          CALL cshaped27(lc1(it),lc2(it),lc3(it),dfidxi,dfideta,dfidzeta,mesh%npoc)
c         rabim d(xi)/dx, itd
          CALL detJac3Dlcd(lc1(it),lc2(it),lc3(it),
     &        x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,
     &        x5,y5,z5,x6,y6,z6,x7,y7,z7,x8,y8,z8,
     &        dxidx,detadx,dzetadx,
     &        dxidy,detady,dzetady,
     &        dxidz,detadz,dzetadz,ajac)

          gradu(dn,1)=0.0D0 ! to nadomestiti z varianto ki utezi po velikosti celice
          gradu(dn,2)=0.0D0
          gradu(dn,3)=0.0D0                    
          DO l=1,mesh%npoc ! vsota za izracun odvoda v dn-tem vozliscu

            dfildx=dfidxi(l)*dxidx+dfideta(l)*detadx+dfidzeta(l)*dzetadx
            dfildy=dfidxi(l)*dxidy+dfideta(l)*detady+dfidzeta(l)*dzetady
            dfildz=dfidxi(l)*dxidz+dfideta(l)*detadz+dfidzeta(l)*dzetadz

            gradu(dn,1)=gradu(dn,1)+u(mesh%idc(ic,l))*dfildx
            gradu(dn,2)=gradu(dn,2)+u(mesh%idc(ic,l))*dfildy
            gradu(dn,3)=gradu(dn,3)+u(mesh%idc(ic,l))*dfildz                        
          END DO  
        END DO         
      END DO      
            
      END   
C----------------------------------------------------------------------C

      SUBROUTINE detJac3Dlcd(xi,eta,zeta,
     &        x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,
     &        x5,y5,z5,x6,y6,z6,x7,y7,z7,x8,y8,z8,
     &        dxidx,detadx,dzetadx,
     &        dxidy,detady,dzetady,
     &        dxidz,detadz,dzetadz,ajac)     

C----------------------------------------------------------------------C
c **********************************************************************
c **                                                                  **
c **  Calculate Jacobian Determinant and derivatives of local coors, 3D  **
c **  -    -----                                 -                    **
c **********************************************************************
      REAL(8) eta1m,eta1p,eta2m,eta2p,eta3m,eta3p,
     &        xi,eta,zeta,
     &        x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,
     &        x5,y5,z5,x6,y6,z6,x7,y7,z7,x8,y8,z8,
     &        aj11,aj12,aj13,aj21,aj22,aj23,aj31,aj32,aj33,
     &        ajac,
     &        dxidx,detadx,dzetadx,
     &        dxidy,detady,dzetady,
     &        dxidz,detadz,dzetadz       
C
C
C
      ETA1M=1.0D0-xi   
      ETA1P=1.0D0+xi
      ETA2M=1.0D0-eta
      ETA2P=1.0D0+eta
      ETA3M=1.0D0-zeta
      ETA3P=1.0D0+zeta
C
C***  Jacobian derivatives  AJ11 = d(x)/d(xi), Aj33= d(z)/d(zeta)
C
      AJ11=0.125D0*(-ETA2M*ETA3M*X1+ETA2M*ETA3M*X2-ETA2P*ETA3M*X3+ETA2P*ETA3M*X4
     &              -ETA2M*ETA3P*X5+ETA2M*ETA3P*X6-ETA2P*ETA3P*X7+ETA2P*ETA3P*X8)

      AJ12=0.125D0*(-ETA2M*ETA3M*Y1+ETA2M*ETA3M*Y2-ETA2P*ETA3M*Y3+ETA2P*ETA3M*Y4
     &              -ETA2M*ETA3P*Y5+ETA2M*ETA3P*Y6-ETA2P*ETA3P*Y7+ETA2P*ETA3P*Y8)

      AJ13=0.125D0*(-ETA2M*ETA3M*Z1+ETA2M*ETA3M*Z2-ETA2P*ETA3M*Z3+ETA2P*ETA3M*Z4
     &              -ETA2M*ETA3P*Z5+ETA2M*ETA3P*Z6-ETA2P*ETA3P*Z7+ETA2P*ETA3P*Z8)
c     
      AJ21=0.125D0*(-ETA1M*ETA3M*X1-ETA1P*ETA3M*X2+ETA1M*ETA3M*X3+ETA1P*ETA3M*X4
     &              -ETA1M*ETA3P*X5-ETA1P*ETA3P*X6+ETA1M*ETA3P*X7+ETA1P*ETA3P*X8)

      AJ22=0.125D0*(-ETA1M*ETA3M*Y1-ETA1P*ETA3M*Y2+ETA1M*ETA3M*Y3+ETA1P*ETA3M*Y4
     &              -ETA1M*ETA3P*Y5-ETA1P*ETA3P*Y6+ETA1M*ETA3P*Y7+ETA1P*ETA3P*Y8)

      AJ23=0.125D0*(-ETA1M*ETA3M*Z1-ETA1P*ETA3M*Z2+ETA1M*ETA3M*Z3+ETA1P*ETA3M*Z4
     &              -ETA1M*ETA3P*Z5-ETA1P*ETA3P*Z6+ETA1M*ETA3P*Z7+ETA1P*ETA3P*Z8)
c
      AJ31=0.125D0*(-ETA1M*ETA2M*X1-ETA1P*ETA2M*X2-ETA1M*ETA2P*X3-ETA1P*ETA2P*X4
     &              +ETA1M*ETA2M*X5+ETA1P*ETA2M*X6+ETA1M*ETA2P*X7+ETA1P*ETA2P*X8)

      AJ32=0.125D0*(-ETA1M*ETA2M*Y1-ETA1P*ETA2M*Y2-ETA1M*ETA2P*Y3-ETA1P*ETA2P*Y4
     &              +ETA1M*ETA2M*Y5+ETA1P*ETA2M*Y6+ETA1M*ETA2P*Y7+ETA1P*ETA2P*Y8)

      AJ33=0.125D0*(-ETA1M*ETA2M*Z1-ETA1P*ETA2M*Z2-ETA1M*ETA2P*Z3-ETA1P*ETA2P*Z4
     &              +ETA1M*ETA2M*Z5+ETA1P*ETA2M*Z6+ETA1M*ETA2P*Z7+ETA1P*ETA2P*Z8)
c
c           Determinanata Jacobija
c
      AJAC=(Aj11*Aj22*Aj33+Aj12*Aj23*Aj31+Aj13*Aj21*Aj32-
     &      Aj11*Aj23*Aj32-Aj12*Aj21*Aj33-Aj13*Aj22*Aj31)      
c
c           Racunam d(xi)/d(x)
c           dobim z obratom jacobijeve matrike
c
c     prvi stolpec
        dxidx  =(aj33*aj22-aj23*aj32)/ajac
        dxidy =(aj23*aj31-aj21*aj33)/ajac
        dxidz=(aj21*aj32-aj22*aj31)/ajac
c     drugi stolpec           
        detadx  =(aj13*aj32-aj33*aj12)/ajac
        detady =(aj33*aj11-aj13*aj31)/ajac
        detadz=(aj12*aj31-aj11*aj32)/ajac
c     tretji stolpec           
        dzetadx  =(aj23*aj12-aj13*aj22)/ajac
        dzetady =(aj21*aj13-aj23*aj11)/ajac
        dzetadz=(aj11*aj22-aj21*aj12)/ajac


      END        
C----------------------------------------------------------------------C

      SUBROUTINE cshape27(xi,eta,zeta,fi,mpom)

C----------------------------------------------------------------------C
c **********************************************************************
c **                                                                  **
c **  Cell SHAPE functions for continuous quadr. 27-node cell         **
c **  -    -----                                 -                    **
c **********************************************************************
      INTEGER mpom
      REAL(8) xi,eta,zeta,fi
      DIMENSION fi(mpom)
      
      REAL(8) ena8,ena4,ena2,epz,emz,epe,eme,emx,epx
      
      ena8=1.0D0/8.0D0
      ena4=1.0D0/4.0D0
      ena2=1.0D0/2.0D0
      epz=1.0D0+zeta
      emz=1.0D0-zeta
      epe=1.0D0+eta
      eme=1.0D0-eta
      epx=1.0D0+xi
      emx=1.0D0-xi   


      fi( 1)=-ena8*zeta*epz*eta*epe*emx*xi  
      fi( 2)= ena8* emz* zeta*  eta*  epe* emx* xi  
      fi( 3)=-ena8* emz* zeta*  eta*  epe* xi*  epx 
      fi( 4)= ena8* zeta*  epz* eta*  epe* xi*  epx 
      fi( 5)= ena8* zeta*  epz* eme* eta*  emx* xi  
      fi( 6)=-ena8* emz* zeta*  eme* eta*  emx* xi  
      fi( 7)= ena8* emz* zeta*  eme* eta*  xi*  epx 
      fi( 8)=-ena8* zeta*  epz* eme* eta*  xi*  epx 
      fi( 9)=-ena4* emz* epz* eta*  epe* emx* xi  
      fi(10)=-ena4* emz* zeta*  eta*  epe* emx* epx 
      fi(11)= ena4* emz* epz* eta*  epe* xi*  epx 
      fi(12)= ena4* zeta*  epz* eta*  epe* emx* epx 
      fi(13)=-ena4* zeta*  epz* eme* epe* emx* xi  
      fi(14)= ena4* emz* zeta*  eme* epe* emx* xi  
      fi(15)=-ena4* emz* zeta*  eme* epe* xi * epx 
      fi(16)= ena4* zeta*  epz* eme* epe* xi * epx 
      fi(17)= ena4* emz* epz* eme* eta*  emx* xi  
      fi(18)= ena4* emz* zeta*  eme* eta*  emx* epx 
      fi(19)=-ena4* emz* epz* eme* eta*  xi * epx 
      fi(20)=-ena4* zeta*  epz* eme* eta*  emx* epx 
      fi(21)= ena2* emz* epz* eta*  epe* emx* epx 
      fi(22)=-ena2* emz* epz* eme* epe* emx* xi  
      fi(23)=-ena2* emz* zeta*  eme* epe* emx* epx 
      fi(24)= ena2* emz* epz* eme* epe* xi*  epx 
      fi(25)= ena2* zeta*  epz* eme* epe* emx* epx 
      fi(26)=-ena2* emz* epz* eme* eta*  emx* epx 
      fi(27)= emz* epz* eme* epe* emx* epx 
     
      END

C----------------------------------------------------------------------C

      SUBROUTINE cshaped27(xi,eta,zeta,dfidxi,dfideta,dfidzeta,mpom)

C----------------------------------------------------------------------C
c **********************************************************************
c **                                                                  **
c **  Cell SHAPE functions for continuous quadr. 27-node cell         **
c **  -    -----                                 -                    **
c **********************************************************************
      INTEGER mpom
      REAL(8) xi,eta,zeta
      REAL(8) dfidxi(mpom),dfideta(mpom),dfidzeta(mpom)
      REAL(8) ena8,ena4,ena2,epz,emz,epe,eme,emx,epx
      REAL(8) e2p1,e2m1,x2p1,x2m1,z2p1,z2m1
      REAL(8) en2m1,xn2m1,zn2m1
      
      ena8=1.0D0/8.0D0
      ena4=1.0D0/4.0D0
      ena2=1.0D0/2.0D0
      epz=1.0D0+zeta
      emz=1.0D0-zeta
      epe=1.0D0+eta
      eme=1.0D0-eta
      epx=1.0D0+xi
      emx=1.0D0-xi
      
      e2p1=2.0D0*eta+1.0D0
      e2m1=2.0D0*eta-1.0D0      
      x2p1=2.0D0*xi+1.0D0
      x2m1=2.0D0*xi-1.0D0
      z2p1=2.0D0*zeta+1.0D0
      z2m1=2.0D0*zeta-1.0D0      
      
      en2m1=eta*eta-1.0D0
      xn2m1=xi*xi-1.0D0
      zn2m1=zeta*zeta-1.0D0            
c
c     d(fi)/d(xi)
c
      dfidxi( 1)=ena8 *zeta  *epz *eta  *epe *x2m1  
      dfidxi( 2)=- ena8 *emz *zeta  *eta  *epe *x2m1  
      dfidxi( 3)=- ena8 *emz *zeta  *eta  *epe *x2p1  
      dfidxi( 4)= ena8 *zeta  *epz *eta  *epe *x2p1  
      dfidxi( 5)=- ena8 *zeta  *epz *eme *eta  *x2m1  
      dfidxi( 6)= ena8 *emz *zeta  *eme *eta  *x2m1  
      dfidxi( 7)= ena8 *emz *zeta  *eme *eta  *x2p1  
      dfidxi( 8)=- ena8 *zeta  *epz *eme *eta  *x2p1  
      dfidxi( 9)= ena4 *emz *epz *eta  *epe *x2m1  
      dfidxi(10)= ena2 *emz *zeta  *eta  *epe *xi   
      dfidxi(11)= ena4 *emz *epz *eta  *epe *x2p1  
      dfidxi(12)= -ena2 *zeta  *epz *eta  *epe *xi   
      dfidxi(13)= ena4 *zeta  *epz *eme *epe *x2m1  
      dfidxi(14)= -ena4 *emz *zeta  *eme *epe *x2m1  
      dfidxi(15)= -ena4 *emz *zeta  *eme *epe *x2p1  
      dfidxi(16)= ena4 *zeta  *epz *eme *epe *x2p1  
      dfidxi(17)= -ena4 *emz *epz *eme *eta  *x2m1  
      dfidxi(18)= -ena2 *emz *zeta  *eme *eta  *xi   
      dfidxi(19)= -ena4 *emz *epz *eme *eta  *x2p1  
      dfidxi(20)= ena2 *zeta  *epz *eme *eta  *xi   
      dfidxi(21)= zn2m1 *eta  *epe *xi   
      dfidxi(22)= ena2 *zn2m1 *en2m1 *x2m1  
      dfidxi(23)= -emz *zeta  *en2m1 *xi   
      dfidxi(24)= ena2 *emz *epz *eme *epe *x2p1  
      dfidxi(25)= zeta  *epz *en2m1 *xi   
      dfidxi(26)= -zn2m1 *eme *eta  *xi   
      dfidxi(27)= -2.0D0 *zn2m1 *en2m1 *xi             
c
c     d(fi)/d(eta)
c
      dfideta( 1)= -ena8 *zeta  *epz *e2p1 *emx *xi   
      dfideta( 2)= ena8 *emz *zeta  *e2p1 *emx *xi   
      dfideta( 3)= -ena8 *emz *zeta  *e2p1 *xi  *epx  
      dfideta( 4)= ena8 *zeta  *epz *e2p1 *xi  *epx  
      dfideta( 5)= -ena8 *zeta  *epz *e2m1 *emx *xi   
      dfideta( 6)= ena8 *emz *zeta  *e2m1 *emx *xi   
      dfideta( 7)= -ena8 *emz *zeta  *e2m1 *xi  *epx  
      dfideta( 8)= ena8 *zeta  *epz *e2m1 *xi  *epx  
      dfideta( 9)= -ena4 *emz *epz *e2p1 *emx *xi   
      dfideta(10)= -ena4 *emz *zeta  *e2p1 *emx *epx  
      dfideta(11)= ena4 *emz *epz *e2p1 *xi  *epx  
      dfideta(12)= ena4 *zeta  *epz *e2p1 *emx *epx  
      dfideta(13)= ena2 *zeta  *epz *eta  *emx *xi   
      dfideta(14)= -ena2 *emz *zeta  *eta  *emx *xi   
      dfideta(15)= ena2 *emz *zeta  *eta  *xi  *epx  
      dfideta(16)= -ena2 *zeta  *epz *eta  *xi  *epx  
      dfideta(17)= -ena4 *emz *epz *e2m1 *emx *xi   
      dfideta(18)= -ena4 *emz *zeta  *e2m1 *emx *epx  
      dfideta(19)= ena4 *emz *epz *e2m1 *xi  *epx  
      dfideta(20)= ena4 *zeta  *epz *e2m1 *emx *epx  
      dfideta(21)= ena2 *emz *epz *e2p1 *emx *epx  
      dfideta(22)= -zn2m1 *eta  *emx *xi   
      dfideta(23)= -emz *zeta  *eta  *xn2m1  
      dfideta(24)= zn2m1 *eta  *xi  *epx  
      dfideta(25)= zeta  *epz *eta  *xn2m1  
      dfideta(26)= ena2 *zn2m1 *e2m1 *xn2m1  
      dfideta(27)= -2.0D0 *zn2m1 *eta  *xn2m1
c
c     d(fi)/d(zeta)
c
      dfidzeta( 1)= -ena8 *z2p1 *eta  *epe *emx *xi   
      dfidzeta( 2)= -ena8 *z2m1 *eta  *epe *emx *xi   
      dfidzeta( 3)= ena8 *z2m1 *eta  *epe *xi  *epx  
      dfidzeta( 4)= ena8 *z2p1 *eta  *epe *xi  *epx  
      dfidzeta( 5)= ena8 *z2p1 *eme *eta  *emx *xi   
      dfidzeta( 6)= ena8 *z2m1 *eme *eta *emx *xi   
      dfidzeta( 7)= -ena8 *z2m1 *eme *eta  *xi  *epx  
      dfidzeta( 8)= -ena8 *z2p1 *eme *eta  *xi  *epx  
      dfidzeta( 9)= ena2 *zeta  *eta  *epe *emx *xi   
      dfidzeta(10)= ena4 *z2m1 *eta  *epe *emx *epx  
      dfidzeta(11)= -ena2 *zeta  *eta  *epe *xi  *epx  
      dfidzeta(12)= ena4 *z2p1 *eta  *epe *emx *epx  
      dfidzeta(13)= -ena4 *z2p1 *eme *epe *emx *xi   
      dfidzeta(14)= -ena4 *z2m1 *eme *epe *emx *xi   
      dfidzeta(15)= ena4 *z2m1 *eme *epe *xi  *epx  
      dfidzeta(16)= ena4 *z2p1 *eme *epe *xi  *epx  
      dfidzeta(17)= -ena2 *zeta  *eme *eta  *emx *xi   
      dfidzeta(18)= -ena4 *z2m1 *eme *eta  *emx *epx  
      dfidzeta(19)= ena2 *zeta  *eme *eta  *xi  *epx  
      dfidzeta(20)= -ena4 *z2p1 *eme *eta  *emx *epx  
      dfidzeta(21)= zeta  *eta  *epe *xn2m1  
      dfidzeta(22)= -zeta  *en2m1 *emx *xi   
      dfidzeta(23)= ena2 *z2m1 *en2m1 *xn2m1  
      dfidzeta(24)= zeta  *en2m1 *xi  *epx  
      dfidzeta(25)= ena2 *z2p1 *eme *epe *emx *epx  
      dfidzeta(26)= -zeta  *eme *eta  *xn2m1  
      dfidzeta(27)= -2.0D0 *zeta  *en2m1 *xn2m1

      END      
