
      SUBROUTINE MeshVolume(gp,mesh)
      INCLUDE 'inc_types.f'

      TYPE(gausstype) :: gp
      TYPE(meshType)  :: mesh
      REAL(8) x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,
     &        x5,y5,z5,x6,y6,z6,x7,y7,z7,x8,y8,z8
      INTEGER ic      
c      REAL(8) tvol
      
c      tvol=0.0D0
      DO ic=1,mesh%nicell
          x1=mesh%x(mesh%idc(ic,6),1)
          y1=mesh%x(mesh%idc(ic,6),2)
          z1=mesh%x(mesh%idc(ic,6),3)          
          x2=mesh%x(mesh%idc(ic,7),1)
          y2=mesh%x(mesh%idc(ic,7),2)
          z2=mesh%x(mesh%idc(ic,7),3)          
          x3=mesh%x(mesh%idc(ic,2),1)
          y3=mesh%x(mesh%idc(ic,2),2)
          z3=mesh%x(mesh%idc(ic,2),3)          
          x4=mesh%x(mesh%idc(ic,3),1)
          y4=mesh%x(mesh%idc(ic,3),2)
          z4=mesh%x(mesh%idc(ic,3),3)          
          x5=mesh%x(mesh%idc(ic,5),1)
          y5=mesh%x(mesh%idc(ic,5),2)
          z5=mesh%x(mesh%idc(ic,5),3)          
          x6=mesh%x(mesh%idc(ic,8),1)
          y6=mesh%x(mesh%idc(ic,8),2)
          z6=mesh%x(mesh%idc(ic,8),3)          
          x7=mesh%x(mesh%idc(ic,1),1)
          y7=mesh%x(mesh%idc(ic,1),2)
          z7=mesh%x(mesh%idc(ic,1),3)          
          x8=mesh%x(mesh%idc(ic,4),1)
          y8=mesh%x(mesh%idc(ic,4),2)
          z8=mesh%x(mesh%idc(ic,4),3)
          CALL CalCellVolume(gp,  
     &    x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,
     &    x5,y5,z5,x6,y6,z6,x7,y7,z7,x8,y8,z8,mesh%vol(ic))
c          tvol=tvol+mesh%vol(ic)
c         print *,ic,mesh%vol(ic)
      END DO
      
c      print *,tvol
      
      END      


      SUBROUTINE CalCellVolume
     &(
     &    gp,
     &    x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,
     &    x5,y5,z5,x6,y6,z6,x7,y7,z7,x8,y8,z8,
     &    volumen
     &)


      INCLUDE 'inc_types.f' 
      TYPE(gausstype) :: gp
      INTEGER ng1,ng2
      INTEGER i,j,k,p

c      
      REAL(8) x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,
     &        x5,y5,z5,x6,y6,z6,x7,y7,z7,x8,y8,z8,
     &        xc0,yc0,zc0,
     &        eta1m,eta1p,eta2m,eta2p,eta3m,eta3p,
     &        aj11,aj12,aj13,aj21,aj22,aj23,aj31,aj32,aj33,
     &        volumen,
     &        ajac,
     &        domega
c
      REAL(8) fig27(27),fig(8)

      ng1=gp%ng1(1) ! dve gaussovi tocki sta dovolj ????
      ng2=gp%ng2(1)

      volumen=0.0D0

      DO K=ng1,ng2
        DO J=ng1,ng2
          DO I=ng1,ng2

            ETA1M=1.0D0-gp%GI(I)
            ETA1P=1.0D0+gp%GI(I)
            ETA2M=1.0D0-gp%GI(J)
            ETA2P=1.0D0+gp%GI(J)
            ETA3M=1.0D0-gp%GI(K)
            ETA3P=1.0D0+gp%GI(K)

              FIG(1)=0.125D0*ETA1M*ETA2M*ETA3M
              FIG(2)=0.125D0*ETA1P*ETA2M*ETA3M
              FIG(3)=0.125D0*ETA1M*ETA2P*ETA3M
              FIG(4)=0.125D0*ETA1P*ETA2P*ETA3M
              FIG(5)=0.125D0*ETA1M*ETA2M*ETA3P
              FIG(6)=0.125D0*ETA1P*ETA2M*ETA3P
              FIG(7)=0.125D0*ETA1M*ETA2P*ETA3P
              FIG(8)=0.125D0*ETA1P*ETA2P*ETA3P

              XC0=FIG(1)*X1+FIG(2)*X2+FIG(3)*X3+FIG(4)*X4
     &           +FIG(5)*X5+FIG(6)*X6+FIG(7)*X7+FIG(8)*X8
              YC0=FIG(1)*Y1+FIG(2)*Y2+FIG(3)*Y3+FIG(4)*Y4
     &           +FIG(5)*Y5+FIG(6)*Y6+FIG(7)*Y7+FIG(8)*Y8
              ZC0=FIG(1)*Z1+FIG(2)*Z2+FIG(3)*Z3+FIG(4)*Z4
     &           +FIG(5)*Z5+FIG(6)*Z6+FIG(7)*Z7+FIG(8)*Z8
C
C***  Jacobian derivatives
C
           AJ11=-ETA2M*ETA3M*X1+ETA2M*ETA3M*X2-ETA2P*ETA3M*X3+ETA2P*ETA3M*X4
     &             -ETA2M*ETA3P*X5+ETA2M*ETA3P*X6-ETA2P*ETA3P*X7+ETA2P*ETA3P*X8

         AJ12=-ETA2M*ETA3M*Y1+ETA2M*ETA3M*Y2-ETA2P*ETA3M*Y3+ETA2P*ETA3M*Y4
     &             -ETA2M*ETA3P*Y5+ETA2M*ETA3P*Y6-ETA2P*ETA3P*Y7+ETA2P*ETA3P*Y8

         AJ13=-ETA2M*ETA3M*Z1+ETA2M*ETA3M*Z2-ETA2P*ETA3M*Z3+ETA2P*ETA3M*Z4
     &             -ETA2M*ETA3P*Z5+ETA2M*ETA3P*Z6-ETA2P*ETA3P*Z7+ETA2P*ETA3P*Z8
c 
             AJ21=-ETA1M*ETA3M*X1-ETA1P*ETA3M*X2+ETA1M*ETA3M*X3+ETA1P*ETA3M*X4
     &             -ETA1M*ETA3P*X5-ETA1P*ETA3P*X6+ETA1M*ETA3P*X7+ETA1P*ETA3P*X8

         AJ22=-ETA1M*ETA3M*Y1-ETA1P*ETA3M*Y2+ETA1M*ETA3M*Y3+ETA1P*ETA3M*Y4
     &             -ETA1M*ETA3P*Y5-ETA1P*ETA3P*Y6+ETA1M*ETA3P*Y7+ETA1P*ETA3P*Y8

         AJ23=-ETA1M*ETA3M*Z1-ETA1P*ETA3M*Z2+ETA1M*ETA3M*Z3+ETA1P*ETA3M*Z4
     &             -ETA1M*ETA3P*Z5-ETA1P*ETA3P*Z6+ETA1M*ETA3P*Z7+ETA1P*ETA3P*Z8
c
              AJ31=-ETA1M*ETA2M*X1-ETA1P*ETA2M*X2-ETA1M*ETA2P*X3-ETA1P*ETA2P*X4
     &             +ETA1M*ETA2M*X5+ETA1P*ETA2M*X6+ETA1M*ETA2P*X7+ETA1P*ETA2P*X8

         AJ32=-ETA1M*ETA2M*Y1-ETA1P*ETA2M*Y2-ETA1M*ETA2P*Y3-ETA1P*ETA2P*Y4
     &             +ETA1M*ETA2M*Y5+ETA1P*ETA2M*Y6+ETA1M*ETA2P*Y7+ETA1P*ETA2P*Y8

         AJ33=-ETA1M*ETA2M*Z1-ETA1P*ETA2M*Z2-ETA1M*ETA2P*Z3-ETA1P*ETA2P*Z4
     &             +ETA1M*ETA2M*Z5+ETA1P*ETA2M*Z6+ETA1M*ETA2P*Z7+ETA1P*ETA2P*Z8
c
              AJAC=(Aj11*Aj22*Aj33+Aj12*Aj23*Aj31+Aj13*Aj21*Aj32-
     &              Aj11*Aj23*Aj32-Aj12*Aj21*Aj33-Aj13*Aj22*Aj31)
c
              AJAC=1.953125D-3*AJAC*gp%OME(I)*gp%OME(J)*gp%OME(K)
c                  1/512=1.953125D-3
c              
              CALL cshape27(gp%GI(I),gp%GI(J),gp%GI(K),fig27,27)
c
              DO P=1,27
                DOMEGA=AJAC*FIG27(P)
                volumen=volumen+DOMEGA
              END DO      
            END DO !I
          END DO !J
        END DO !K
             
      END
        
        
        
        
        
        
        
      
C______________________________________________________________________________
      SUBROUTINE GaussPosWeights(gaus)
C
C     Defines positions and weights for gauss quadrature
C     Bronstein 730, 441
C      
      INCLUDE 'inc_types.f'
      TYPE(gausstype) :: gaus
      
      ALLOCATE(gaus%gi(156),gaus%ome(156))
      ALLOCATE(gaus%ng1(8),gaus%ng2(8))
      
C---  N =   2  ( ng1 =  1 , ng2 =  2 )
      gaus%ng1(1)=1
      gaus%ng2(1)=2
      gaus%gi(1)   = -0.5773502691896258D0
      gaus%gi(2)   =  0.5773502691896258D0
      gaus%ome(1)  =  1.0000000000000000D0
      gaus%ome(2)  =  1.0000000000000000D0
      
C---  N =   4 ( ng1 =  3 , ng2 =  6 )
      gaus%ng1(2)=3
      gaus%ng2(2)=6
      gaus%gi(3)   = -0.8611363115940526D0
      gaus%gi(4)   = -0.3399810435848563D0
      gaus%gi(5)   =  0.3399810435848563D0
      gaus%gi(6)   =  0.8611363115940526D0
      gaus%ome(3)  =  0.3478548451374539D0
      gaus%ome(4)  =  0.6521451548625462D0
      gaus%ome(5)  =  0.6521451548625462D0
      gaus%ome(6)  =  0.3478548451374539D0
      
C---  N =   6 ( ng1 =  7 , ng2 = 12 )
      gaus%ng1(3)=7
      gaus%ng2(3)=12
      gaus%gi(7)   = -0.9324695142031520D0
      gaus%gi(8)   = -0.6612093864662645D0
      gaus%gi(9)   = -0.2386191860831969D0
      gaus%gi(10)  =  0.2386191860831971D0
      gaus%gi(11)  =  0.6612093864662646D0
      gaus%gi(12)  =  0.9324695142031521D0
      gaus%ome(7)  =  0.1713244923791704D0
      gaus%ome(8)  =  0.3607615730481386D0
      gaus%ome(9)  =  0.4679139345726910D0
      gaus%ome(10) =  0.4679139345726910D0
      gaus%ome(11) =  0.3607615730481386D0
      gaus%ome(12) =  0.1713244923791703D0
      
C---  N =   8 ( ng1 =  13 , ng2 = 20 )
      gaus%ng1(4)=13
      gaus%ng2(4)=20
      gaus%gi(13)  = -0.9602898564975362D0
      gaus%gi(14)  = -0.7966664774136267D0
      gaus%gi(15)  = -0.5255324099163290D0
      gaus%gi(16)  = -0.1834346424956499D0
      gaus%gi(17)  =  0.1834346424956499D0
      gaus%gi(18)  =  0.5255324099163290D0
      gaus%gi(19)  =  0.7966664774136267D0
      gaus%gi(20)  =  0.9602898564975362D0
      gaus%ome(13) =  0.1012285362903762D0
      gaus%ome(14) =  0.2223810344533745D0
      gaus%ome(15) =  0.3137066458778873D0
      gaus%ome(16) =  0.3626837833783620D0
      gaus%ome(17) =  0.3626837833783620D0
      gaus%ome(18) =  0.3137066458778873D0
      gaus%ome(19) =  0.2223810344533745D0
      gaus%ome(20) =  0.1012285362903764D0
      
C---  N =  16 ( ng1 =  21 , ng2 = 36 )
      gaus%ng1(5)=21
      gaus%ng2(5)=36
      gaus%gi(21) = -0.9894009349916499D0
      gaus%gi(22) = -0.9445750230732326D0
      gaus%gi(23) = -0.8656312023878318D0
      gaus%gi(24) = -0.7554044083550030D0
      gaus%gi(25) = -0.6178762444026437D0
      gaus%gi(26) = -0.4580167776572274D0
      gaus%gi(27) = -0.2816035507792589D0
      gaus%gi(28) = -0.0950125098376375D0
      gaus%gi(29) =  0.0950125098376374D0
      gaus%gi(30) =  0.2816035507792590D0
      gaus%gi(31) =  0.4580167776572274D0
      gaus%gi(32) =  0.6178762444026437D0
      gaus%gi(33) =  0.7554044083550031D0
      gaus%gi(34) =  0.8656312023878318D0
      gaus%gi(35) =  0.9445750230732326D0
      gaus%gi(36) =  0.9894009349916500D0
      gaus%ome(21)=  0.0271524594117541D0
      gaus%ome(22)=  0.0622535239386479D0
      gaus%ome(23)=  0.0951585116824928D0
      gaus%ome(24)=  0.1246289712555339D0
      gaus%ome(25)=  0.1495959888165767D0
      gaus%ome(26)=  0.1691565193950025D0
      gaus%ome(27)=  0.1826034150449236D0
      gaus%ome(28)=  0.1894506104550685D0
      gaus%ome(29)=  0.1894506104550685D0
      gaus%ome(30)=  0.1826034150449236D0
      gaus%ome(31)=  0.1691565193950025D0
      gaus%ome(32)=  0.1495959888165767D0
      gaus%ome(33)=  0.1246289712555338D0
      gaus%ome(34)=  0.0951585116824927D0
      gaus%ome(35)=  0.0622535239386479D0
      gaus%ome(36)=  0.0271524594117539D0
      
C---  N =  32( ng1 =  37 , ng2 = 68 )
      gaus%ng1(6)=37
      gaus%ng2(6)=68
      gaus%gi(37) = -0.9972638618494815D0
      gaus%gi(38) = -0.9856115115452683D0
      gaus%gi(39) = -0.9647622555875064D0
      gaus%gi(40) = -0.9349060759377397D0
      gaus%gi(41) = -0.8963211557660521D0
      gaus%gi(42) = -0.8493676137325700D0
      gaus%gi(43) = -0.7944837959679424D0
      gaus%gi(44) = -0.7321821187402897D0
      gaus%gi(45) = -0.6630442669302152D0
      gaus%gi(46) = -0.5877157572407623D0
      gaus%gi(47) = -0.5068999089322294D0
      gaus%gi(48) = -0.4213512761306354D0
      gaus%gi(49) = -0.3318686022821277D0
      gaus%gi(50) = -0.2392873622521372D0
      gaus%gi(51) = -0.1444719615827965D0
      gaus%gi(52) = -0.0483076656877383D0
      gaus%gi(53) =  0.0483076656877384D0
      gaus%gi(54) =  0.1444719615827965D0
      gaus%gi(55) =  0.2392873622521372D0
      gaus%gi(56) =  0.3318686022821278D0
      gaus%gi(57) =  0.4213512761306355D0
      gaus%gi(58) =  0.5068999089322294D0
      gaus%gi(59) =  0.5877157572407624D0
      gaus%gi(60) =  0.6630442669302153D0
      gaus%gi(61) =  0.7321821187402897D0
      gaus%gi(62) =  0.7944837959679424D0
      gaus%gi(63) =  0.8493676137325699D0
      gaus%gi(64) =  0.8963211557660521D0
      gaus%gi(65) =  0.9349060759377397D0
      gaus%gi(66) =  0.9647622555875065D0
      gaus%gi(67) =  0.9856115115452684D0
      gaus%gi(68) =  0.9972638618494816D0
      gaus%ome(37)=  0.0070186100094701D0
      gaus%ome(38)=  0.0162743947309057D0
      gaus%ome(39)=  0.0253920653092621D0
      gaus%ome(40)=  0.0342738629130214D0
      gaus%ome(41)=  0.0428358980222267D0
      gaus%ome(42)=  0.0509980592623762D0
      gaus%ome(43)=  0.0586840934785356D0
      gaus%ome(44)=  0.0658222227763618D0
      gaus%ome(45)=  0.0723457941088485D0
      gaus%ome(46)=  0.0781938957870703D0
      gaus%ome(47)=  0.0833119242269468D0
      gaus%ome(48)=  0.0876520930044038D0
      gaus%ome(49)=  0.0911738786957639D0
      gaus%ome(50)=  0.0938443990808046D0
      gaus%ome(51)=  0.0956387200792749D0
      gaus%ome(52)=  0.0965400885147278D0
      gaus%ome(53)=  0.0965400885147278D0
      gaus%ome(54)=  0.0956387200792749D0
      gaus%ome(55)=  0.0938443990808046D0
      gaus%ome(56)=  0.0911738786957639D0
      gaus%ome(57)=  0.0876520930044038D0
      gaus%ome(58)=  0.0833119242269468D0
      gaus%ome(59)=  0.0781938957870703D0
      gaus%ome(60)=  0.0723457941088485D0
      gaus%ome(61)=  0.0658222227763619D0
      gaus%ome(62)=  0.0586840934785355D0
      gaus%ome(63)=  0.0509980592623762D0
      gaus%ome(64)=  0.0428358980222267D0
      gaus%ome(65)=  0.0342738629130214D0
      gaus%ome(66)=  0.0253920653092620D0
      gaus%ome(67)=  0.0162743947309056D0
      gaus%ome(68)=  0.0070186100094699D0

C---  N =  40 ( ng1 =  69 , ng2 = 108 )
      gaus%ng1(7)=69
      gaus%ng2(7)=108
      gaus%gi(69)= -0.998237709710559200350D00
      gaus%gi(70)= -0.990726238699457006453D00
      gaus%gi(71)= -0.977259949983774262663D00
      gaus%gi(72)= -0.957916819213791655805D00
      gaus%gi(73)= -0.932812808278676533361D00
      gaus%gi(74)= -0.902098806968874296728D00
      gaus%gi(75)= -0.865959503212259503821D00
      gaus%gi(76)= -0.824612230833311663196D00
      gaus%gi(77)= -0.778305651426519387695D00
      gaus%gi(78)= -0.727318255189927103281D00
      gaus%gi(79)= -0.671956684614179548379D00
      gaus%gi(80)= -0.612553889667980237953D00
      gaus%gi(81)= -0.549467125095128202076D00
      gaus%gi(82)= -0.483075801686178712909D00
      gaus%gi(83)= -0.413779204371605001525D00
      gaus%gi(84)= -0.341994090825758473007D00
      gaus%gi(85)= -0.268152185007253681141D00
      gaus%gi(86)= -0.192697580701371099716D00
      gaus%gi(87)= -0.116084070675255208483D00
      gaus%gi(88)= -0.038772417506050821933D00

      gaus%gi(89)=  0.038772417506050821933D00
      gaus%gi(90)=  0.116084070675255208483D00
      gaus%gi(91)=  0.192697580701371099716D00
      gaus%gi(92)=  0.268152185007253681141D00
      gaus%gi(93)=  0.341994090825758473007D00
      gaus%gi(94)=  0.413779204371605001525D00
      gaus%gi(95)=  0.483075801686178712909D00
      gaus%gi(96)=  0.549467125095128202076D00
      gaus%gi(97)=  0.612553889667980237953D00
      gaus%gi(98)=  0.671956684614179548379D00
      gaus%gi(99)=  0.727318255189927103281D00
      gaus%gi(100)= 0.778305651426519387695D00
      gaus%gi(101)= 0.824612230833311663196D00
      gaus%gi(102)= 0.865959503212259503821D00
      gaus%gi(103)= 0.902098806968874296728D00
      gaus%gi(104)= 0.932812808278676533361D00
      gaus%gi(105)= 0.957916819213791655805D00
      gaus%gi(106)= 0.977259949983774262663D00
      gaus%gi(107)= 0.990726238699457006453D00
      gaus%gi(108)= 0.998237709710559200350D00

      gaus%ome(69)= 0.004521277098533191258D00
      gaus%ome(70)= 0.010498284531152813615D00
      gaus%ome(71)= 0.016421058381907888713D00
      gaus%ome(72)= 0.022245849194166957262D00
      gaus%ome(73)= 0.027937006980023401098D00
      gaus%ome(74)= 0.033460195282547847393D00
      gaus%ome(75)= 0.038782167974472017640D00
      gaus%ome(76)= 0.043870908185673271992D00
      gaus%ome(77)= 0.048695807635072232061D00
      gaus%ome(78)= 0.053227846983936824355D00
      gaus%ome(79)= 0.057439769099391551367D00
      gaus%ome(80)= 0.061306242492928939167D00
      gaus%ome(81)= 0.064804013456601038075D00
      gaus%ome(82)= 0.067912045815233903826D00
      gaus%ome(83)= 0.070611647391286779695D00
      gaus%ome(84)= 0.072886582395804059061D00
      gaus%ome(85)= 0.074723169057968264200D00
      gaus%ome(86)= 0.076110361900626242372D00
      gaus%ome(87)= 0.077039818164247965588D00
      gaus%ome(88)= 0.077505947978424811264D00

      gaus%ome(89)= 0.077505947978424811264D00
      gaus%ome(90)= 0.077039818164247965588D00
      gaus%ome(91)= 0.076110361900626242372D00
      gaus%ome(92)= 0.074723169057968264200D00
      gaus%ome(93)= 0.072886582395804059061D00
      gaus%ome(94)= 0.070611647391286779695D00
      gaus%ome(95)= 0.067912045815233903826D00
      gaus%ome(96)= 0.064804013456601038075D00
      gaus%ome(97)= 0.061306242492928939167D00
      gaus%ome(98)= 0.057439769099391551367D00
      gaus%ome(99)= 0.053227846983936824355D00
      gaus%ome(100)=0.048695807635072232061D00
      gaus%ome(101)=0.043870908185673271992D00
      gaus%ome(102)=0.038782167974472017640D00
      gaus%ome(103)=0.033460195282547847393D00
      gaus%ome(104)=0.027937006980023401098D00
      gaus%ome(105)=0.022245849194166957262D00
      gaus%ome(106)=0.016421058381907888713D00
      gaus%ome(107)=0.010498284531152813615D00
      gaus%ome(108)=0.004521277098533191258D00

C---  N =  48 ( ng1 = 109 , ng2 = 156 )
      gaus%ng1(8)=109
      gaus%ng2(8)=156
      gaus%gi(109)=-0.998771007252426118601D00
      gaus%gi(110)=-0.993530172266350757548D00
      gaus%gi(111)=-0.984124583722826857745D00
      gaus%gi(112)=-0.970591592546247250461D00
      gaus%gi(113)=-0.952987703160430860723D00
      gaus%gi(114)=-0.931386690706554333114D00
      gaus%gi(115)=-0.905879136715569672822D00
      gaus%gi(116)=-0.876572020274247885906D00
      gaus%gi(117)=-0.843588261624393530711D00
      gaus%gi(118)=-0.807066204029442627083D00
      gaus%gi(119)=-0.767159032515740339254D00
      gaus%gi(120)=-0.724034130923814654674D00
      gaus%gi(121)=-0.677872379632663905212D00
      gaus%gi(122)=-0.628867396776513623995D00
      gaus%gi(123)=-0.577224726083972703818D00
      gaus%gi(124)=-0.523160974722233033678D00
      gaus%gi(125)=-0.466902904750958404545D00
      gaus%gi(126)=-0.408686481990716729916D00
      gaus%gi(127)=-0.348755886292160738160D00
      gaus%gi(128)=-0.287362487355455576736D00
      gaus%gi(129)=-0.224763790394689061225D00
      gaus%gi(130)=-0.161222356068891718056D00
      gaus%gi(131)=-0.097004699209462698930D00
      gaus%gi(132)=-0.032380170962869362033D00

      gaus%gi(133)= 0.032380170962869362033D00
      gaus%gi(134)= 0.097004699209462698930D00
      gaus%gi(135)= 0.161222356068891718056D00
      gaus%gi(136)= 0.224763790394689061225D00
      gaus%gi(137)= 0.287362487355455576736D00
      gaus%gi(138)= 0.348755886292160738160D00
      gaus%gi(139)= 0.408686481990716729916D00
      gaus%gi(140)= 0.466902904750958404545D00
      gaus%gi(141)= 0.523160974722233033678D00
      gaus%gi(142)= 0.577224726083972703818D00
      gaus%gi(143)= 0.628867396776513623995D00
      gaus%gi(144)= 0.677872379632663905212D00
      gaus%gi(145)= 0.724034130923814654674D00
      gaus%gi(146)= 0.767159032515740339254D00
      gaus%gi(147)= 0.807066204029442627083D00
      gaus%gi(148)= 0.843588261624393530711D00
      gaus%gi(149)= 0.876572020274247885906D00
      gaus%gi(150)= 0.905879136715569672822D00
      gaus%gi(151)= 0.931386690706554333114D00
      gaus%gi(152)= 0.952987703160430860723D00
      gaus%gi(153)= 0.970591592546247250461D00
      gaus%gi(154)= 0.984124583722826857745D00
      gaus%gi(155)= 0.993530172266350757548D00
      gaus%gi(156)= 0.998771007252426118601D00

      gaus%ome(109)= 0.003153346052305838633D00
      gaus%ome(110)= 0.007327553901276262102D00
      gaus%ome(111)= 0.011477234579234539490D00
      gaus%ome(112)= 0.015579315722943848728D00
      gaus%ome(113)= 0.019616160457355527814D00
      gaus%ome(114)= 0.023570760839324379141D00
      gaus%ome(115)= 0.027426509708356948200D00
      gaus%ome(116)= 0.031167227832798088902D00
      gaus%ome(117)= 0.034777222564770438893D00
      gaus%ome(118)= 0.038241351065830706317D00
      gaus%ome(119)= 0.041545082943464749214D00
      gaus%ome(120)= 0.044674560856694280419D00
      gaus%ome(121)= 0.047616658492490474826D00
      gaus%ome(122)= 0.050359035553854474958D00
      gaus%ome(123)= 0.052890189485193667096D00
      gaus%ome(124)= 0.055199503699984162868D00
      gaus%ome(125)= 0.057277292100403215705D00
      gaus%ome(126)= 0.059114839698395635746D00
      gaus%ome(127)= 0.060704439165893880053D00
      gaus%ome(128)= 0.062039423159892663904D00
      gaus%ome(129)= 0.063114192286254025657D00
      gaus%ome(130)= 0.063924238584648186624D00
      gaus%ome(131)= 0.064466164435950082207D00
      gaus%ome(132)= 0.064737696812683922503D00

      gaus%ome(133)= 0.064737696812683922503D00
      gaus%ome(134)= 0.064466164435950082207D00
      gaus%ome(135)= 0.063924238584648186624D00
      gaus%ome(136)= 0.063114192286254025657D00
      gaus%ome(137)= 0.062039423159892663904D00
      gaus%ome(138)= 0.060704439165893880053D00
      gaus%ome(139)= 0.059114839698395635746D00
      gaus%ome(140)= 0.057277292100403215705D00
      gaus%ome(141)= 0.055199503699984162868D00
      gaus%ome(142)= 0.052890189485193667096D00
      gaus%ome(143)= 0.050359035553854474958D00
      gaus%ome(144)= 0.047616658492490474826D00
      gaus%ome(145)= 0.044674560856694280419D00
      gaus%ome(146)= 0.041545082943464749214D00
      gaus%ome(147)= 0.038241351065830706317D00
      gaus%ome(148)= 0.034777222564770438893D00
      gaus%ome(149)= 0.031167227832798088902D00
      gaus%ome(150)= 0.027426509708356948200D00
      gaus%ome(151)= 0.023570760839324379141D00
      gaus%ome(152)= 0.019616160457355527814D00
      gaus%ome(153)= 0.015579315722943848728D00
      gaus%ome(154)= 0.011477234579234539490D00
      gaus%ome(155)= 0.007327553901276262102D00
      gaus%ome(156)= 0.003153346052305838633D00
c
      END
      
C______________________________        